diff --git a/MAINTAINERS b/MAINTAINERS
index 5273ab9812..f463188f1d 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -1301,6 +1301,12 @@ vDPA Drivers
 T: git://dpdk.org/next/dpdk-next-virtio
 F: drivers/vdpa/meson.build
 
+Corigine nfp vDPA
+M: Chaoyong He <chaoyong.he@corigine.com>
+F: drivers/vdpa/nfp/
+F: doc/guides/vpdadevs/nfp.rst
+F: doc/guides/vdpadevs/features/nfp.ini
+
 Intel ifc
 M: Xiao Wang <xiao.w.wang@intel.com>
 F: drivers/vdpa/ifc/
diff --git a/doc/guides/rel_notes/release_23_11.rst b/doc/guides/rel_notes/release_23_11.rst
index 0a6fc76a9d..f6dde6fb9d 100644
--- a/doc/guides/rel_notes/release_23_11.rst
+++ b/doc/guides/rel_notes/release_23_11.rst
@@ -153,6 +153,11 @@ New Features
 
   * Added inline IPsec offload based on the security framework.
 
+* **Add new vDPA PMD based on Corigine NFP devices.**
+
+  Added a new Corigine NFP vDPA (``nfp_vdpa``) PMD.
+  See the :doc:`../vdpadevs/nfp` guide for more details on this driver.
+
 * **Updated Wangxun ngbe driver.**
 
   * Added 100M and auto-neg support in YT PHY fiber mode.
diff --git a/doc/guides/vdpadevs/features/nfp.ini b/doc/guides/vdpadevs/features/nfp.ini
new file mode 100644
index 0000000000..d830feafe0
--- /dev/null
+++ b/doc/guides/vdpadevs/features/nfp.ini
@@ -0,0 +1,8 @@
+;
+; Supported features of the 'nfp' vDPA driver.
+;
+; Refer to default.ini for the full list of available driver features.
+;
+[Features]
+Linux                   = Y
+x86-64                  = Y
diff --git a/doc/guides/vdpadevs/index.rst b/doc/guides/vdpadevs/index.rst
index cc2f858042..b0191a3a1d 100644
--- a/doc/guides/vdpadevs/index.rst
+++ b/doc/guides/vdpadevs/index.rst
@@ -14,4 +14,5 @@ which can be used from an application through vhost API.
     features_overview
     ifc
     mlx5
+    nfp
     sfc
diff --git a/doc/guides/vdpadevs/nfp.rst b/doc/guides/vdpadevs/nfp.rst
new file mode 100644
index 0000000000..63636b2882
--- /dev/null
+++ b/doc/guides/vdpadevs/nfp.rst
@@ -0,0 +1,54 @@
+..  SPDX-License-Identifier: BSD-3-Clause
+    Copyright (c) 2023 Corigine, Inc.
+
+NFP vDPA driver
+===============
+
+The NFP vDPA (vhost data path acceleration) driver (**librte_nfp_vdpa**)
+provides support for the Netronome and Corigine's NFP-6xxx, NFP-4xxx
+and NFP-38xx product lines.
+
+NFP vDPA implementation
+-----------------------
+
+NFP VF device can be configured in the net device or vDPA mode.
+Adding "class=vdpa" parameter helps to specify that this device is to
+be used in vDPA mode. If this parameter is not specified, device
+will be probed by net/nfp driver and will used as a VF net device.
+
+This PMD uses (common/nfp) code to access the device firmware.
+
+Per-Device Parameters
+~~~~~~~~~~~~~~~~~~~~~
+
+The following per-device parameters can be passed via EAL PCI device
+allowlist option like "-a 02:00.0,arg1=value1,...".
+
+- ``class`` [net|vdpa] (default **net**)
+
+  Choose the mode of operation of nfp device.
+  **net** device will work as network device and will be probed by net/nfp driver.
+  **vdpa** device will work as vdpa device and will be probed by vdpa/nfp driver.
+  If this parameter is not specified then nfp device will operate as network device.
+
+Dynamic Logging Parameters
+~~~~~~~~~~~~~~~~~~~~~~~~~~
+
+One may leverage EAL option "--log-level" to change default levels
+for the log types supported by the driver. The option is used with
+an argument typically consisting of two parts separated by a colon.
+
+Level value is the last part which takes a symbolic name (or integer).
+Log type is the former part which may shell match syntax.
+Depending on the choice of the expression, the given log level may
+be used either for some specific log type or for a subset of types.
+
+NFP vDPA PMD provides the following log types available for control:
+
+- ``pmd.vdpa.nfp.vdpa`` (default level is **notice**)
+
+  Affects driver-wide messages unrelated to any particular devices.
+
+- ``pmd.vdpa.nfp.core`` (default level is **notice**)
+
+  Affects the core logic of this PMD.
diff --git a/drivers/vdpa/meson.build b/drivers/vdpa/meson.build
index 77412c7d09..896e8e0304 100644
--- a/drivers/vdpa/meson.build
+++ b/drivers/vdpa/meson.build
@@ -8,6 +8,7 @@ endif
 drivers = [
         'ifc',
         'mlx5',
+        'nfp',
         'sfc',
 ]
 std_deps = ['bus_pci', 'kvargs']
diff --git a/drivers/vdpa/nfp/meson.build b/drivers/vdpa/nfp/meson.build
new file mode 100644
index 0000000000..5eff240055
--- /dev/null
+++ b/drivers/vdpa/nfp/meson.build
@@ -0,0 +1,13 @@
+# SPDX-License-Identifier: BSD-3-Clause
+# Copyright (c) 2023 Corigine, Inc.
+
+if not is_linux or not dpdk_conf.get('RTE_ARCH_64')
+    build = false
+    reason = 'only supported on 64-bit Linux'
+endif
+
+sources = files(
+        'nfp_vdpa_log.c',
+)
+
+deps += ['vhost']
diff --git a/drivers/vdpa/nfp/nfp_vdpa_log.c b/drivers/vdpa/nfp/nfp_vdpa_log.c
new file mode 100644
index 0000000000..f5ada20713
--- /dev/null
+++ b/drivers/vdpa/nfp/nfp_vdpa_log.c
@@ -0,0 +1,9 @@
+/* SPDX-License-Identifier: BSD-3-Clause
+ * Copyright (c) 2023 Corigine, Inc.
+ * All rights reserved.
+ */
+
+#include "nfp_vdpa_log.h"
+
+RTE_LOG_REGISTER_SUFFIX(nfp_logtype_core, core, NOTICE);
+RTE_LOG_REGISTER_SUFFIX(nfp_logtype_vdpa, vdpa, NOTICE);
diff --git a/drivers/vdpa/nfp/nfp_vdpa_log.h b/drivers/vdpa/nfp/nfp_vdpa_log.h
new file mode 100644
index 0000000000..cf342329b1
--- /dev/null
+++ b/drivers/vdpa/nfp/nfp_vdpa_log.h
@@ -0,0 +1,21 @@
+/* SPDX-License-Identifier: BSD-3-Clause
+ * Copyright (c) 2023 Corigine, Inc.
+ * All rights reserved.
+ */
+
+#ifndef __NFP_VDPA_LOG_H__
+#define __NFP_VDPA_LOG_H__
+
+#include <rte_log.h>
+
+extern int nfp_logtype_vdpa;
+#define DRV_VDPA_LOG(level, fmt, args...) \
+	rte_log(RTE_LOG_ ## level, nfp_logtype_vdpa, \
+		"NFP_VDPA: %s(): " fmt "\n", __func__, ## args)
+
+extern int nfp_logtype_core;
+#define DRV_CORE_LOG(level, fmt, args...) \
+	rte_log(RTE_LOG_ ## level, nfp_logtype_core, \
+		"NFP_CORE: %s(): " fmt "\n", __func__, ## args)
+
+#endif /* __NFP_VDPA_LOG_H__ */